int redPin = 5;
int greenPin = 6;
int bluePin = 9;

long NUM_COLOURS = 16777216;

void setup() {
  pinMode(redPin, OUTPUT);     
  pinMode(greenPin, OUTPUT);     
  pinMode(bluePin, OUTPUT);
  
  randomSeed(analogRead(0));
    
}

void loop() {
  setColour(random(NUM_COLOURS));
  delay(1000);
}

void setColour(long colour){
  analogWrite(redPin, getRedPart(colour));
  analogWrite(greenPin, getGreenPart(colour));
  analogWrite(bluePin, getBluePart(colour));
}

int getRedPart(long colour){
  return getBits(colour,16);
}

int getGreenPart(long colour){
  return getBits(colour,8);
}

int getBluePart(long colour){
  return getBits(colour,0);
}

int getBits(long colour, int startBit){
  int result = 0;
  int pos = 0;
  while(true){
    int bytePos = pos - startBit;
    if(bytePos < 0){
      colour = colour >> 1;
    }
    else if(bytePos < 8){
      byte byteBit = 1 << bytePos;      
      result = result | (colour & byteBit);
    }
    else{
      return result;
    }
    pos = pos + 1;
  }
}
